import java.util.*;
import java.util.function.*;

public class Solution {
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);

        Integer n = scanner.nextInt();
        Integer m = scanner.nextInt();

        List<Integer> x = new ArrayList<>(Arrays.asList(new Integer[] {0}));
        for (Integer i = 1; i <= n; ++i) {
            x.add(scanner.nextInt());
        }

        List<Integer> p = new ArrayList<>();
        for (Integer i = 1; i <= n; ++i) {
            p.add(i);
        }
        p.sort((a, b) -> { return Integer.compare(x.get(b), x.get(a)); });
        p.add(0, 0);

        Function<Integer, Integer> xx = (i) -> { return x.get(p.get(i)); };

        Integer k = 0;
        for (Integer i = 1; i <= n; ++i) {
            if (xx.apply(i) > m / i) {
                k = i;
                break;
            }
        }

        if (k == 0) {
            System.out.println("Alessia");
            System.out.flush();
            List<Boolean> chosen = Arrays.asList(new Boolean[m + 1]);
            Collections.fill(chosen, false);
            for (Integer t = 1; t <= n; ++t) {
                Integer y = xx.apply(t);
                Integer last = 0;
                Integer a = 0;
                for (Integer i = 1; i <= m; ++i) {
                    if (chosen.get(i)) {
                        last = i;
                    }
                    if (!chosen.get(i) && i - last == y) {
                        a = last + 1;
                        break;
                    }
                }
                System.out.printf("%d %d\n", y, a);
                System.out.flush();
                Integer b = scanner.nextInt();
                chosen.set(b, true);
            }
        } else {
            System.out.println("Bernardo");
            System.out.flush();
            Integer yy = xx.apply(k);
            for (Integer t = 1; t <= n; ++t) {
                Integer y = scanner.nextInt();
                Integer a = scanner.nextInt();
                Boolean done = false;
                for (Integer i = a; i <= a + y - 1; ++i) {
                    if (i % yy == 0) {
                        System.out.println(i);
                        done = true;
                        break;
                    }
                }
                if (!done) System.out.println(a);
                System.out.flush();
            }
        }
    }
}
